<template>
  <li>
    <div>
      <span v-if="isVerified" class="verified">Verified</span>
    </div>
    <div class="center">
      <img :src="pictureUrl" alt="User Picture" width="200" height="250" />
    </div>
    <div>
      <h3>{{ firstName }} {{ lastName }}</h3>
    </div>
    <div>
      <h4>{{ email }}</h4>
    </div>
    <section v-if="profileIsVisible">
      <div>
        <h4>Address:</h4>
        {{ address }}
      </div>
      <div>
        <h4>Birth Date:</h4>
        {{ birthDate }}
      </div>
      <div>
        <h4>Register Date:</h4>
        {{ registerDate }}
      </div>
      <div>
        <h4>Register Time:</h4>
        {{ registerTime }}
      </div>
    </section>
    <div class="buttons">
      <base-button link :to="detailsLink" mode="outline"
        >View Details
      </base-button>
      <base-button @click="toggleProfileVisibility"
        >{{ buttonTitle }}
      </base-button>
      <base-button v-if="!isVerified" @click="verify" mode="flat"
        >Verify
      </base-button>
    </div>
  </li>
</template>

<script setup>
import { ref, computed, defineProps } from "vue";
import { useRoute } from "vue-router";
import { useStore } from "vuex";

const props = defineProps([
  "id",
  "pictureUrl",
  "firstName",
  "lastName",
  "email",
  "address",
  "birthDate",
  "registerDate",
  "registerTime",
]);

const profileIsVisible = ref(false);
const route = useRoute();
const store = useStore();

const buttonTitle = computed(function () {
  return profileIsVisible.value ? "Hide more info" : "Show more info";
});

function toggleProfileVisibility() {
  profileIsVisible.value = !profileIsVisible.value;
}

function verify() {
  store.dispatch("verifyProfile", props.id);
}

const isVerified = computed(function () {
  const users = store.getters.users;
  const selectedUser = users.find((user) => user.id === props.id);
  return selectedUser["isVerified"];
});

const detailsLink = computed(function () {
  return route.path + "/" + props.id;
});
</script>

<style scoped>
li {
  margin: 1rem 0;
  border: 1px solid #424242;
  border-radius: 12px;
  padding: 1rem;
}

h3 {
  font-size: 1.5rem;
}

h3,
h4 {
  margin: 0.5rem 0;
}

div {
  margin: 0.5rem 0;
}

.buttons {
  margin: 1rem 0 0 0;
}

.verified {
  background-color: #3d008d;
  color: white;
  border-radius: 30px;
  padding: 0.5rem 1.5rem;
  display: inline-block;
  margin-right: 0.5rem;
}
</style>
